from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, Int, String

Rsat_Random_Genes_V0_1_0 = CommandToolBuilder(tool="rsat_random_genes", base_command=["rsat", "random-genes"], inputs=[ToolInput(tag="in_help", input_type=Boolean(optional=True), prefix="-help", doc=InputDocumentation(doc="(must be first argument) display options")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="-v", doc=InputDocumentation(doc="verbose")), ToolInput(tag="in_specified_standard_output", input_type=File(optional=True), prefix="-o", doc=InputDocumentation(doc="if not specified, the standard output is used.\nThis allows to place the command within a pipe.")), ToolInput(tag="in_org", input_type=Boolean(optional=True), prefix="-org", doc=InputDocumentation(doc="organism")), ToolInput(tag="in_features", input_type=Boolean(optional=True), prefix="-features", doc=InputDocumentation(doc="alternate feature table. This option allows to speify\nan alternate file where the ORF locations are found.\nSee below for a description of the feature file format.")), ToolInput(tag="in_feat_type", input_type=Boolean(optional=True), prefix="-feattype", doc=InputDocumentation(doc="Feature type.\nSupported: gene,mRNA,tRNA,rRNA,scRNA,misc_RNA,CDS,start_codon,stop_codon,exon")), ToolInput(tag="in_replace", input_type=Boolean(optional=True), prefix="-replace", doc=InputDocumentation(doc="random selection with replacement\n(a same ORF might appear several times in the output)")), ToolInput(tag="in_number_random_genes", input_type=Boolean(optional=True), prefix="-n", doc=InputDocumentation(doc="#    number of random genes to return")), ToolInput(tag="in_groups_number_random", input_type=Boolean(optional=True), prefix="-g", doc=InputDocumentation(doc="#    groups (number of random groups).")), ToolInput(tag="in_pairs", input_type=Boolean(optional=True), prefix="-pairs", doc=InputDocumentation(doc="#\nnumber of random pairs of genes to return. Each row of\nthe output contains two genes, separated by a tab.")), ToolInput(tag="in_fam", input_type=Int(optional=True), prefix="-fam", doc=InputDocumentation(doc="file\nA 2-column file containing gene names in the first\ncolumn and group (cluster) name in the second column.\n(same format as for multiple-group-analysis).\nThe program returns a file of the same size as the\ninput, where input genes have been substituted by\nrandom genes.")), ToolInput(tag="in_repeat", input_type=Boolean(optional=True), prefix="-repeat", doc=InputDocumentation(doc="#\n(requires the option -fam)\nNumber of repetitions for each input group.\nThis option generates, for each input group, R output\nrandom gene selections of the same size.")), ToolInput(tag="in_random_genes", input_type=String(), position=0, doc=InputDocumentation(doc="2002 by Jacques van Helden (Jacques.van-Helden@univ-amu.fr)")), ToolInput(tag="in_organism_dot", input_type=String(), position=0, doc=InputDocumentation(doc="There are several modes of utilization.\n(1) -n       returns random genes.\n(2) -g       groups. Create a group file with g groups of n\ngenes (n must be specified)\n(3) -pairs   returns random pairs of genes.\n(4) -fam     takes a group file (see multiple-group-analysis)\nas input, and return another group file with\nthe same number of groups, the same number\nof random genes per group as in the input\nfile. This allows to deal with groups of\ndifferent sizes in the same file, and to\nperform negative controls in exactly the same\nconditions as the test.")), ToolInput(tag="in_util", input_type=String(), position=0, doc=InputDocumentation(doc="USAGE")), ToolInput(tag="in_families_dot", input_type=String(), position=0, doc=InputDocumentation(doc="It is a text file containing 2 columns separated by")), ToolInput(tag="in_example", input_type=String(), position=0, doc=InputDocumentation(doc="; genes responding to Phosphate stress")), ToolInput(tag="in_pho_five", input_type=Int(), position=1, doc=InputDocumentation(doc="PHO")), ToolInput(tag="in_pho_eight", input_type=Int(), position=2, doc=InputDocumentation(doc="PHO")), ToolInput(tag="in_dal_five", input_type=Int(), position=0, doc=InputDocumentation(doc="NIT")), ToolInput(tag="in_gap_one", input_type=Int(), position=1, doc=InputDocumentation(doc="NIT"))], outputs=[ToolOutput(tag="out_specified_standard_output", output_type=File(optional=True), selector=InputSelector(input_to_select="in_specified_standard_output", type_hint=File()), doc=OutputDocumentation(doc="if not specified, the standard output is used.\nThis allows to place the command within a pipe."))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Rsat_Random_Genes_V0_1_0().translate("wdl", allow_empty_container=True)

